## mysql-5.5 5.5.29

=== CMakeLists.txt ===
# Copyright (c) 2006, 2012, Oracle and/or its affiliates. All rights reserved.
# 
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

CMAKE_MINIMUM_REQUIRED(VERSION 2.6)
# Avoid warnings in higher versions
if("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" GREATER 2.6)
 CMAKE_POLICY(VERSION 2.8)
endif()

MESSAGE(STATUS "Running cmake version ${CMAKE_VERSION}")

SET(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

# First, decide about build type (debug or release)
# If custom compiler flags are set or cmake is invoked with -DCMAKE_BUILD_TYPE, 
# respect user wishes and do not (re)define CMAKE_BUILD_TYPE. If WITH_DEBUG{_FULL} 
# is given, set CMAKE_BUILD_TYPE = Debug. Otherwise, use Relwithdebinfo.


IF(DEFINED CMAKE_BUILD_TYPE)
  SET(HAVE_CMAKE_BUILD_TYPE TRUE)
ENDIF()
SET(CUSTOM_C_FLAGS $ENV{CFLAGS})

OPTION(WITH_DEBUG "Use dbug/safemutex" OFF)

# Distinguish between community and non-community builds, with the
# default being a community build. This does not impact the feature
# set that will be compiled in; it's merely provided as a hint to
# custom packaging steps.
OPTION(COMMUNITY_BUILD "Set to true if this is a community build" ON) 

# Use a default manufacturer if no manufacturer was identified.
SET(MANUFACTURER_DOCSTRING
  "Set the entity that appears as the manufacturer of packages that support a manufacturer field.")
IF(NOT DEFINED MANUFACTURER) 
  SET(MANUFACTURER "Built from Source" CACHE  STRING ${MANUFACTURER_DOCSTRING})
  MARK_AS_ADVANCED(MANUFACTURER)
ENDIF()

# We choose to provide WITH_DEBUG as alias to standard CMAKE_BUILD_TYPE=Debug
# which turns out to be not trivial, as this involves synchronization 
# between CMAKE_BUILD_TYPE and WITH_DEBUG. Besides, we have to deal with cases
# where WITH_DEBUG is  reset from ON to OFF  and here we need to reset 
# CMAKE_BUILD_TYPE to either none or default RelWithDebInfo

SET(BUILDTYPE_DOCSTRING
 "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or
 CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel")
 
IF(WITH_DEBUG)
  SET(CMAKE_BUILD_TYPE "Debug" CACHE STRING ${BUILDTYPE_DOCSTRING} FORCE)
  SET(MYSQL_MAINTAINER_MODE ON CACHE BOOL
      "MySQL maintainer-specific development environment")
  IF(UNIX AND NOT APPLE)
    # Compiling with PIC speeds up embedded build, on PIC sensitive systems 
    # Predefine it to ON, in case user chooses to build embedded. 
    SET(WITH_PIC ON CACHE BOOL "Compile with PIC")
  ENDIF()
  SET(OLD_WITH_DEBUG 1 CACHE INTERNAL "" FORCE)
ELSEIF(NOT HAVE_CMAKE_BUILD_TYPE OR OLD_WITH_DEBUG)
  IF(CUSTOM_C_FLAGS)
    SET(CMAKE_BUILD_TYPE "" CACHE STRING ${BUILDTYPE_DOCSTRING} FORCE)
  ELSE(CMAKE_BUILD_TYPE MATCHES "Debug" OR NOT HAVE_CMAKE_BUILD_TYPE)
    SET(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING 
       ${BUILDTYPE_DOCSTRING} FORCE)
  ENDIF()
  SET(OLD_WITH_DEBUG 0 CACHE INTERNAL "" FORCE)
ENDIF()

# Optionally set project name, e.g.
# foo.xcodeproj (mac) or foo.sln (windows)
SET(MYSQL_PROJECT_NAME_DOCSTRING "MySQL project name")
IF(DEFINED MYSQL_PROJECT_NAME)
  SET(MYSQL_PROJECT_NAME ${MYSQL_PROJECT_NAME} CACHE STRING
      ${MYSQL_PROJECT_NAME_DOCSTRING} FORCE)
ELSE()
  SET(MYSQL_PROJECT_NAME "MySQL" CACHE STRING
      ${MYSQL_PROJECT_NAME_DOCSTRING} FORCE)
  MARK_AS_ADVANCED(MYSQL_PROJECT_NAME)
ENDIF()
PROJECT(${MYSQL_PROJECT_NAME})

IF(BUILD_CONFIG)
  INCLUDE(
  ${CMAKE_SOURCE_DIR}/cmake/build_configurations/${BUILD_CONFIG}.cmake)
ENDIF()

# Include the platform-specific file. To allow exceptions, this code
# looks for files in order of how specific they are. If there is, for
# example, a generic Linux.cmake and a version-specific
# Linux-2.6.28-11-generic, it will pick Linux-2.6.28-11-generic and
# include it. It is then up to the file writer to include the generic
# version if necessary.
FOREACH(_base
    ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_VERSION}-${CMAKE_SYSTEM_PROCESSOR}
    ${CMAKE_SYSTEM_NAME}-${CMAKE_SYSTEM_VERSION}
    ${CMAKE_SYSTEM_NAME})
  SET(_file ${CMAKE_SOURCE_DIR}/cmake/os/${_base}.cmake)
  IF(EXISTS ${_file})
    INCLUDE(${_file})
    BREAK()
  ENDIF()
ENDFOREACH()



# Following autotools tradition, add preprocessor definitions
# specified in environment variable CPPFLAGS
IF(DEFINED ENV{CPPFLAGS})
  ADD_DEFINITIONS($ENV{CPPFLAGS})
ENDIF()

#
# Control aspects of the development environment which are
# specific to MySQL maintainers and developers.
#
INCLUDE(maintainer)

OPTION(MYSQL_MAINTAINER_MODE
       "MySQL maintainer-specific development environment" OFF)

# Whether the maintainer mode compiler options should be enabled.
IF(MYSQL_MAINTAINER_MODE)
  IF(CMAKE_C_COMPILER_ID MATCHES "GNU")
    SET_MYSQL_MAINTAINER_GNU_C_OPTIONS()
  ENDIF()
  IF(CMAKE_CXX_COMPILER_ID MATCHES "GNU")
    SET_MYSQL_MAINTAINER_GNU_CXX_OPTIONS()
  ENDIF()
  IF(CMAKE_C_COMPILER_ID MATCHES "Intel")
    SET_MYSQL_MAINTAINER_INTEL_C_OPTIONS()
  ENDIF()
  IF(CMAKE_CXX_COMPILER_ID MATCHES "Intel")
    SET_MYSQL_MAINTAINER_INTEL_CXX_OPTIONS()
  ENDIF()
ENDIF()

# Add macros
INCLUDE(character_sets)
INCLUDE(zlib)
INCLUDE(ssl)
INCLUDE(readline)
INCLUDE(mysql_version)
INCLUDE(libutils)
INCLUDE(dtrace)
INCLUDE(plugin)
INCLUDE(install_macros)
INCLUDE(install_layout)
INCLUDE(mysql_add_executable)

# Handle options
OPTION(DISABLE_SHARED 
 "Don't build shared libraries, compile code as position-dependent" OFF)
IF(DISABLE_SHARED)
  SET(WITHOUT_DYNAMIC_PLUGINS 1)
ENDIF()
OPTION(ENABLED_PROFILING "Enable profiling" ON)
OPTION(CYBOZU "" OFF)
OPTION(BACKUP_TEST "" OFF)
OPTION(WITHOUT_SERVER OFF)
IF(UNIX)
  OPTION(WITH_VALGRIND "Valgrind instrumentation" OFF)
ENDIF()
OPTION (WITH_UNIT_TESTS "Compile MySQL with unit tests" ON)
MARK_AS_ADVANCED(CYBOZU BACKUP_TEST WITHOUT_SERVER DISABLE_SHARED)

 
OPTION(ENABLE_DEBUG_SYNC "Enable debug sync (debug builds only)" ON) 
IF(ENABLE_DEBUG_SYNC) 
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -DENABLED_DEBUG_SYNC") 
  SET(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -DENABLED_DEBUG_SYNC") 
ENDIF() 
 
OPTION(ENABLE_GCOV "Enable gcov (debug, Linux builds only)" OFF)
IF (ENABLE_GCOV AND NOT WIN32 AND NOT APPLE)
  SET(CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_C_FLAGS_DEBUG "${CMAKE_C_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage")
  SET(CMAKE_EXE_LINKER_FLAGS_DEBUG "${CMAKE_EXE_LINKER_FLAGS_DEBUG} -fprofile-arcs -ftest-coverage -lgcov")
ENDIF()

OPTION(ENABLED_LOCAL_INFILE
 "If we should should enable LOAD DATA LOCAL by default" ${IF_WIN})
MARK_AS_ADVANCED(ENABLED_LOCAL_INFILE)

OPTION(WITH_FAST_MUTEXES "Compile with fast mutexes" OFF)
MARK_AS_ADVANCED(WITH_FAST_MUTEXES)

# Set DBUG_OFF and other optional release-only flags for non-debug project types
FOREACH(BUILD_TYPE RELEASE RELWITHDEBINFO MINSIZEREL)
  FOREACH(LANG C CXX)
    SET(CMAKE_${LANG}_FLAGS_${BUILD_TYPE} 
     "${CMAKE_${LANG}_FLAGS_${BUILD_TYPE}} -DDBUG_OFF")
    IF(WITH_FAST_MUTEXES)
      SET(CMAKE_${LANG}_FLAGS_${BUILD_TYPE} 
        "${CMAKE_${LANG}_FLAGS_${BUILD_TYPE}} -DMY_PTHREAD_FASTMUTEX=1")
    ENDIF()
  ENDFOREACH()
ENDFOREACH()

IF(NOT CMAKE_BUILD_TYPE
    AND NOT CMAKE_GENERATOR MATCHES "Visual Studio" 
    AND NOT CMAKE_GENERATOR MATCHES "Xcode") 
    # This is the case of no CMAKE_BUILD_TYPE choosen, typical for VS and Xcode
    # or if custom C flags are set. In VS and Xcode for non-Debug configurations 
    # DBUG_OFF is already correctly set. Use DBUG_OFF for Makefile based projects 
    # without build type too, unless user specifically requests DBUG. 
    IF(NOT CMAKE_C_FLAGS MATCHES "-DDBUG_ON")
      ADD_DEFINITIONS(-DDBUG_OFF)
    ENDIF()
ENDIF()

# Add safemutex for debug configurations, except on Windows
# (safemutex has never worked on Windows)
IF(WITH_DEBUG AND NOT WIN32)
  FOREACH(LANG C CXX)
      SET(CMAKE_${LANG}_FLAGS_DEBUG
          "${CMAKE_${LANG}_FLAGS_DEBUG} -DSAFE_MUTEX")
  ENDFOREACH()
ENDIF()


# Set commonly used variables
IF(WIN32)
  SET(DEFAULT_MYSQL_HOME "C:/Program Files/MySQL/MySQL Server ${MYSQL_BASE_VERSION}" )
  SET(SHAREDIR share)
ELSE()
  SET(DEFAULT_MYSQL_HOME ${CMAKE_INSTALL_PREFIX})
  SET(SHAREDIR ${DEFAULT_MYSQL_HOME}/${INSTALL_MYSQLSHAREDIR})
ENDIF()

SET(DEFAULT_BASEDIR "${DEFAULT_MYSQL_HOME}")
IF(INSTALL_MYSQLDATADIR MATCHES "^/.*")
  SET(MYSQL_DATADIR ${INSTALL_MYSQLDATADIR} CACHE PATH "default MySQL data directory")
ELSE()
  SET(MYSQL_DATADIR "${DEFAULT_MYSQL_HOME}/${INSTALL_MYSQLDATADIR}" CACHE PATH "default MySQL data directory")
ENDIF()
SET(DEFAULT_CHARSET_HOME "${DEFAULT_MYSQL_HOME}")
SET(PLUGINDIR "${DEFAULT_MYSQL_HOME}/${INSTALL_PLUGINDIR}")
IF(SYSCONFDIR)
  SET(DEFAULT_SYSCONFDIR "${SYSCONFDIR}")
ENDIF()


# Run platform tests
INCLUDE(configure.cmake)

# Common defines and includes
ADD_DEFINITIONS(-DHAVE_CONFIG_H)
INCLUDE_DIRECTORIES(${CMAKE_CURRENT_BINARY_DIR}/include)

# Add bundled or system zlib.
MYSQL_CHECK_ZLIB_WITH_COMPRESS()
# Optionally add bundled yassl/taocrypt or system openssl.
MYSQL_CHECK_SSL()
# Add readline or libedit.
MYSQL_CHECK_READLINE()

#
# Setup maintainer mode options by the end. Platform checks are
# not run with the warning options as to not perturb fragile checks
# (i.e. do not make warnings into errors).
#
IF(MYSQL_MAINTAINER_MODE)
  # Set compiler flags required under maintainer mode.
  MESSAGE(STATUS "C warning options: ${MY_MAINTAINER_C_WARNINGS}")
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${MY_MAINTAINER_C_WARNINGS}")
  MESSAGE(STATUS "C++ warning options: ${MY_MAINTAINER_CXX_WARNINGS}")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${MY_MAINTAINER_CXX_WARNINGS}")
ENDIF()

IF(NOT WITHOUT_SERVER)
SET (MYSQLD_STATIC_PLUGIN_LIBS "" CACHE INTERNAL "")
 # Add storage engines and plugins.
 CONFIGURE_PLUGINS()
ENDIF()

ADD_SUBDIRECTORY(include)
ADD_SUBDIRECTORY(dbug)
ADD_SUBDIRECTORY(strings)
ADD_SUBDIRECTORY(vio)
ADD_SUBDIRECTORY(regex)
ADD_SUBDIRECTORY(mysys)
ADD_SUBDIRECTORY(libmysql)


IF(WITH_UNIT_TESTS)
 ENABLE_TESTING()
ENDIF()
IF(WITH_UNIT_TESTS)
  ADD_SUBDIRECTORY(unittest/mytap)
  ADD_SUBDIRECTORY(unittest/mysys)
ENDIF()

ADD_SUBDIRECTORY(extra)
IF(NOT WITHOUT_SERVER)
  ADD_SUBDIRECTORY(tests)
  ADD_SUBDIRECTORY(client)
  ADD_SUBDIRECTORY(sql)
  ADD_SUBDIRECTORY(sql/share)
  ADD_SUBDIRECTORY(libservices)
  OPTION (WITH_EMBEDDED_SERVER "Compile MySQL with embedded server" OFF)
  IF(WITH_EMBEDDED_SERVER) 
   ADD_SUBDIRECTORY(libmysqld)
   ADD_SUBDIRECTORY(libmysqld/examples)
  ENDIF(WITH_EMBEDDED_SERVER)

  ADD_SUBDIRECTORY(mysql-test)
  ADD_SUBDIRECTORY(mysql-test/lib/My/SafeProcess)
  ADD_SUBDIRECTORY(support-files)
  ADD_SUBDIRECTORY(scripts)
  ADD_SUBDIRECTORY(sql-bench)
  IF(UNIX)
    ADD_SUBDIRECTORY(man)
  ENDIF()
  IF(EXISTS ${CMAKE_SOURCE_DIR}/internal/CMakeLists.txt)
    ADD_SUBDIRECTORY(internal)
  ENDIF()
  ADD_SUBDIRECTORY(packaging/rpm-uln)
ENDIF()

INCLUDE(cmake/abi_check.cmake)
INCLUDE(cmake/tags.cmake)

CONFIGURE_FILE(config.h.cmake   ${CMAKE_BINARY_DIR}/include/my_config.h)
CONFIGURE_FILE(config.h.cmake   ${CMAKE_BINARY_DIR}/include/config.h)
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/include/mysql_version.h.in
               ${CMAKE_BINARY_DIR}/include/mysql_version.h )
CONFIGURE_FILE(${CMAKE_SOURCE_DIR}/sql/sql_builtin.cc.in
    ${CMAKE_BINARY_DIR}/sql/sql_builtin.cc)
CONFIGURE_FILE(
    ${CMAKE_SOURCE_DIR}/cmake/info_macros.cmake.in ${CMAKE_BINARY_DIR}/info_macros.cmake @ONLY)

# Handle the "INFO_*" files.
INCLUDE(${CMAKE_BINARY_DIR}/info_macros.cmake)

=== debian/changelog ===
mysql-5.5 (5.5.29-0ubuntu1) raring; urgency=low

  * SECURITY UPDATE: Update to 5.5.29 to fix security issues (LP: #1100264)
    - http://www.oracle.com/technetwork/topics/security/cpujan2013-1515902.html
  * debian/patches/CVE-2012-5611.patch: removed, included upstream.
  * debian/patches/38_scripts__mysqld_safe.sh__signals.patch: refreshed.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Wed, 16 Jan 2013 08:29:25 -0500

mysql-5.5 (5.5.28-0ubuntu4) raring; urgency=low

  * Add autopkgtests for running the upstream tests against the installed
    packages, and building a simple program against libmysqlclient.

 -- Daniel Kessel <d.kessel@gmx.de>  Thu, 03 Jan 2013 18:21:53 +0100

mysql-5.5 (5.5.28-0ubuntu3) raring; urgency=low

  * SECURITY UPDATE: arbitrary code execution via long argument
    - debian/patches/CVE-2012-5611.patch: don't overflow buffer in
      sql/sql_acl.cc, add tests to mysql-test/t/information_schema.test,
      mysql-test/r/information_schema.result.
    - CVE-2012-5611

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Mon, 10 Dec 2012 09:59:17 -0500

mysql-5.5 (5.5.28-0ubuntu2) raring; urgency=low

  * Set CMAKE_BUILD_TYPE to RelWithDebInfo instead of Debug so
    optimizations are restored, and so that DBUG_ASSERT does not crash
    the server.

 -- Clint Byrum <clint@ubuntu.com>  Wed, 28 Nov 2012 23:16:59 -0800

mysql-5.5 (5.5.28-0ubuntu1) raring; urgency=low

  [ Alex Bligh ]
  * debian/mysql-server-5.5.postinst: Add Create_tablespace_priv which
    was missed in the 5.1 -> 5.5 transition, and regressed GRANT 
    privileges for the debian-sys-maint user. (LP: #1062716)

  [ Clint Byrum ]
  * d/rules: Build with debug symbols (LP: #1014872)

 -- Clint Byrum <clint@ubuntu.com>  Tue, 27 Nov 2012 03:50:57 -0800

mysql-5.5 (5.5.28-0ubuntu0.12.10.1) quantal-security; urgency=low

  * SECURITY UPDATE: Update to 5.5.28 to fix security issues (LP: #1068158)
    - http://www.oracle.com/technetwork/topics/security/cpuoct2012-1515893.html
  * debian/patches/fix-mysqlhotcopy.patch: removed, included upstream.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 18 Oct 2012 11:09:57 -0400

=== debian/control ===
Source: mysql-5.5
Section: database
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian MySQL Maintainers <pkg-mysql-maint@lists.alioth.debian.org>
Uploaders: Norbert Tretkowski <norbert@tretkowski.de>, Clint Byrum <clint@ubuntu.com>
Build-Depends: libtool (>= 1.4.2-7), procps | hurd,  debhelper (>= 8.1.3~), file (>= 3.28), libncurses5-dev (>= 5.0-6), perl (>= 5.6.0), libwrap0-dev (>= 7.6-8.3), zlib1g-dev (>= 1:1.1.3-5), libreadline-dev, psmisc, po-debconf, chrpath, doxygen-latex, ghostscript,  gawk, bison, lsb-release, hardening-wrapper, cmake, dh-apparmor, gcc-4.4 [any-i386], g++-4.4 [any-i386], libaio-dev[linux-any]
Standards-Version: 3.9.2
Homepage: http://dev.mysql.com/
XS-Testsuite: autopkgtest

Package: libmysqlclient18
Section: libs
Architecture: any
Depends: mysql-common (>= ${source:Version}), ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: multiarch-support, ${misc:Pre-Depends}
Multi-Arch: same
Description: MySQL database client library
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the client library.

Package: libmysqld-pic
Architecture: any
Section: libdevel
Depends: libmysqlclient-dev (>= ${source:Version}), ${misc:Depends}
Description: MySQL database development files
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the -fPIC version of the embedded server library.

Package: libmysqld-dev
Architecture: any
Section: libdevel
Depends: libmysqlclient-dev (>= ${source:Version}), ${misc:Depends}
Description: MySQL embedded database development files
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the embedded server library and header files.

Package: libmysqlclient-dev
Architecture: any
Section: libdevel
Depends: libmysqlclient18 (= ${binary:Version}), zlib1g-dev, , ${shlibs:Depends}, ${misc:Depends}
Conflicts: libmysqlclient14-dev, libmysqlclient12-dev, libmysqlclient10-dev, libmysqlclient15-dev
Provides: libmysqlclient15-dev
Replaces: libmysqlclient15-dev
Description: MySQL database development files
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes development libraries and header files.

Package: mysql-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: mysql-common-4.1
Provides: mysql-common-4.1
Replaces: mysql-common-4.1
Breaks: mysql-server-5.1, mysql-client-5.1, mysql-server-core-5.1, mysql-client-core-5.1
Multi-Arch: foreign
Description: MySQL database common files, e.g. /etc/mysql/my.cnf
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes files needed by all versions of the client library,
 e.g. /etc/mysql/my.cnf.

Package: mysql-client-core-5.5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-client (<< ${source:Version}), mysql-client-5.0, mysql-client-core-5.1
Replaces: mysql-client (<< ${source:Version}), mysql-client-5.0, mysql-client-core-5.1
Description: MySQL database core client binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the core client files, as used by Akonadi.

Package: mysql-client-5.5
Architecture: any
Depends: debianutils (>=1.6), libdbi-perl, libdbd-mysql-perl (>= 1.2202), mysql-common (>= ${source:Version}), ${perl:Depends}, ${shlibs:Depends}, ${misc:Depends}, mysql-client-core-5.5, libterm-readkey-perl
Provides: virtual-mysql-client, mysql-client, mysql-client-4.1
Breaks: mysql-client (<< ${source:Version}), mysql-client-5.0, mysql-client-5.1
Replaces: mysql-client (<< ${source:Version}), mysql-client-5.0, mysql-client-5.1
Description: MySQL database client binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the client binaries and the additional tools
 innotop and mysqlreport.

Package: mysql-server-core-5.5
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: mysql-server-5.1, mysql-server-5.0, mysql-server-core-5.1
Provides: mysql-server-core
Replaces: mysql-server-core-5.0, mysql-server-core-5.1, mysql-server-5.0, mysql-server-5.1, mysql-server-core-5.1
Description: MySQL database server binaries
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the server binaries but doesn't contain all the
 infrastructure needed to setup system databases.

Package: mysql-server-5.5
Architecture: any
Suggests: tinyca, mailx
Recommends: libhtml-template-perl
Pre-Depends: mysql-common (>= ${source:Version}), adduser (>= 3.40), debconf
Depends: mysql-client-5.5 (>= ${source:Version}), libdbi-perl, perl (>= 5.6), ${shlibs:Depends}, ${misc:Depends}, psmisc, passwd, lsb-base (>= 3.0-10), mysql-server-core-5.5 (= ${binary:Version}), upstart (>= 0.6.7-2)
Breaks: mysql-server (<< ${source:Version}), mysql-server-4.1, mysql-server-5.1, libmysqlclient-dev ( << 5.5.17~ )
Provides: virtual-mysql-server
Replaces: mysql-server (<< ${source:Version}), mysql-server-5.1,  mysql-server-5.0, mysql-server-4.1, libmysqlclient-dev ( << 5.5.17~ )
Description: MySQL database server binaries and system database setup 
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package contains all the infrastructure needed to setup system
 databases.

Package: mysql-server
Architecture: all
Depends: mysql-server-5.5
Description: MySQL database server (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mysql-server (currently mysql-server-5.5), as determined by the MySQL
 maintainers. Install this package if in doubt about which MySQL
 version you need. That will install the version recommended by the
 package maintainers.
 .
 MySQL is a fast, stable and true multi-user, multi-threaded SQL database
 server. SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.

Package: mysql-client
Architecture: all
Depends: mysql-client-5.5
Description: MySQL database client (metapackage depending on the latest version)
 This is an empty package that depends on the current "best" version of
 mysql-client (currently mysql-client-5.5), as determined by the MySQL
 maintainers.  Install this package if in doubt about which MySQL version
 you want, as this is the one we consider to be in the best shape.

Package: mysql-testsuite
Architecture: all
Depends: mysql-testsuite-5.5
Description: MySQL testsuite
 This is an empty package that depends on the current "best" version of
 mysql-testsuite (currently mysql-testsuite-5.5), as determined by the
 MySQL maintainers.  Install this package if in doubt about which MySQL
 version you want, as this is the one we consider to be in the best shape.

Package: mysql-testsuite-5.5
Architecture: any
Depends: mysql-server, mysql-client, ${misc:Depends},  ${shlibs:Depends}
Conflicts: mysql-testsuite (<< ${source:Version})
Description: MySQL testsuite
 MySQL is a fast, stable, and true multi-user, multi-threaded SQL database
 server.  SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the MySQL testsuite.

Package: mysql-source-5.5
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: MySQL source
 MySQL is a fast, stable, and true multi-user, multi-threaded SQL database
 server.  SQL (Structured Query Language) is the most popular database query
 language in the world. The main goals of MySQL are speed, robustness and
 ease of use.
 .
 This package includes the MySQL source code as configured before building.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1

PACKAGE=mysql-5.5

TMP=$(CURDIR)/debian/tmp/

ARCH = $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ARCH_OS = $(shell dpkg-architecture -qDEB_BUILD_ARCH_OS)
DEB_BUILD_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_HOST_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEBVERSION = $(shell dpkg-parsechangelog | awk '/^Version: / { print $$2 }' | sed 's/^.*-//' )

ifneq (,$(filter $(ARCH), i386 kfreebsd-i386 hurd-i386))
    USE_THIS_GCC_VERSION:=-4.4
endif

export MYSQL_BUILD_CC=$(DEB_HOST_GNU_TYPE)-gcc$(USE_THIS_GCC_VERSION)
export MYSQL_BUILD_CXX=$(DEB_HOST_GNU_TYPE)-g++$(USE_THIS_GCC_VERSION)


DEB_SOURCE_PACKAGE ?= $(strip $(shell egrep '^Source: ' debian/control | cut -f 2 -d ':'))
DEB_VERSION ?= $(shell dpkg-parsechangelog | egrep '^Version:' | cut -f 2 -d ' ')
DEB_NOEPOCH_VERSION ?= $(shell echo $(DEB_VERSION) | cut -d: -f2-)
DEB_UPSTREAM_VERSION ?= $(shell echo $(DEB_NOEPOCH_VERSION) | sed 's/-[^-]*$$//')
DEB_UPSTREAM_VERSION_MAJOR_MINOR := $(shell echo $(DEB_UPSTREAM_VERSION) | sed -r -n 's/^([0-9]+\.[0-9]+).*/\1/p')
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

EXPORTED_SOURCE_TARBALL = debian/mysql-source-5.5.tar.gz

DISTRIBUTION = $(shell lsb_release -i -s)

MAKE_J = -j$(shell if [ -f /proc/cpuinfo ] ; then grep -c processor.* /proc/cpuinfo ; else echo 1 ; fi)
ifeq (${MAKE_J}, -j0)
  MAKE_J = -j1
endif

MAKE_TEST_TARGET=test-force
ifneq ($(findstring fulltest,$(DEB_BUILD_OPTIONS)),)
# make test-bt is the testsuite run by the MySQL build team 
# before a release, but it is long
    MAKE_TEST_TARGET=test-bt
endif

USE_ASSEMBLER=--enable-assembler 

ifneq (,$(filter $(ARCH), amd64 i386))
    TESTSUITE_FAIL_CMD=exit 1
else
    TESTSUITE_FAIL_CMD=true
endif

BUILDDIR = builddir
BUILDDIR_PIC = builddir-pic
builddir = $(if $(findstring -pic,$@),$(BUILDDIR_PIC),$(BUILDDIR))

# This causes seg11 crashes if LDAP is used for groups in /etc/nsswitch.conf
# so it is disabled by default although, according to MySQL, it brings >10%
# performance gain if enabled. See #299382.
ifeq ($(STATIC_MYSQLD), 1)
    USE_STATIC_MYSQLD=--with-mysqld-ldflags=-all-static
endif
		
# See http://blogs.innodb.com/wp/2010/04/innodb-performance-aio-linux/
# Also #659565
ifneq (,$(findstring linux-gnu,$(DEB_HOST_GNU_TYPE)))
    USE_LINUX_NATIVE_AIO:=-DLINUX_NATIVE_AIO=ON
endif

configure-stamp-pic: FORCE_FPIC_CFLAGS=-fPIC
configure-stamp-pic: FORCE_FPIC=-DWITH_PIC=On -DINSTALL_LIBDIR=lib/mysql

configure: patch configure-stamp
configure-pic: patch configure-stamp-pic
configure-stamp configure-stamp-pic:
	@echo "RULES.$@"
	dh_testdir

ifneq ($(ARCH_OS),hurd)
	if [ ! -d /proc/self ]; then echo "/proc IS NEEDED" 1>&2; exit 1; fi 
endif

	( test -d $(builddir) || mkdir $(builddir) ) && cd $(builddir) && \
	sh -c  'PATH=$${MYSQL_BUILD_PATH:-"/bin:/usr/bin"} \
	    	CC=$${MYSQL_BUILD_CC:-gcc} \
		CFLAGS=$${MYSQL_BUILD_CFLAGS:-"-O2 -DBIG_JOINS=1 ${FORCE_FPIC_CFLAGS} -fno-strict-aliasing"} \
	    	CXX=$${MYSQL_BUILD_CXX:-g++} \
	    	CXXFLAGS=$${MYSQL_BUILD_CXXFLAGS:-"-O3 -DBIG_JOINS=1 -felide-constructors -fno-exceptions -fno-rtti ${FORCE_FPIC_CFLAGS} -fno-strict-aliasing"} \
	    cmake -DCMAKE_INSTALL_PREFIX=/usr \
		\
		$(FORCE_FPIC) \
		-DMYSQL_UNIX_ADDR=/var/run/mysqld/mysqld.sock \
	       	-DMYSQL_USER=mysql \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DWITH_LIBWRAP=ON \
		-DWITH_READLINE=OFF \
		-DWITH_LIBEDIT=OFF \
		$(USE_STATIC_MYSQLD) \
		$(USE_LINUX_NATIVE_AIO) \
		-DWITH_SSL=bundled \
	    -DCOMPILATION_COMMENT="($(DISTRIBUTION))" \
	    -DMYSQL_SERVER_SUFFIX="-$(DEBVERSION)" \
	    -DSYSTEM_TYPE="debian-linux-gnu" \
	    -DINSTALL_LAYOUT=RPM \
	    -DINSTALL_LIBDIR=lib/$(DEB_HOST_MULTIARCH) \
	    -DINSTALL_PLUGINDIR=lib/mysql/plugin \
        -DWITH_EMBEDDED_SERVER=ON \
        -DHAVE_EMBEDDED_PRIVILEGE_CONTROL=ON \
	    -DWITH_ARCHIVE_STORAGE_ENGINE=ON \
	    -DWITH_BLACKHOLE_STORAGE_ENGINE=ON \
	    -DWITH_FEDERATED_STORAGE_ENGINE=ON \
		-DWITH_EXTRA_CHARSETS=all ..'
		
	#       --sysconfdir=/etc/mysql  -- Appends /etc/mysql after ~/ in the my.cnf search patch!
	#
	#	--with-debug
	
	touch $@


build: build-stamp build-stamp-pic

build-stamp: configure
	@echo "RULES.$@"
	dh_testdir
	
	[ -f $(EXPORTED_SOURCE_TARBALL) ] || tar -zcf $(EXPORTED_SOURCE_TARBALL) \
	--exclude=debian . \
	--transform="s,^\./,mysql-5.5/,"

	cd $(builddir) && $(MAKE) $(MAKE_J)

ifeq ($(findstring nocheck,$(DEB_BUILD_OPTIONS)),)
	# Don't know why the following is necessary...
	cp unittest/unit.pl $(builddir)/unittest/
	cp -r mysql-test/* $(builddir)/mysql-test/
	cp -r sql/share/* $(builddir)/sql/share/
	cp -r scripts/*sql $(builddir)/scripts/
	if [ ! -f testsuite-stamp ] ; then \
	  cd $(builddir) && $(MAKE) $(MAKE_TEST_TARGET) || $(TESTSUITE_FAIL_CMD) ; \
	fi
endif

	touch testsuite-stamp

	touch build-stamp

MAKE_PIC = cd $(builddir) && $(MAKE) $(MAKE_J)

build-stamp-pic: configure-pic
	@echo "RULES.$@"
	# Build libmysqld dependencies
	#(MAKE_PIC) -C include
	#(MAKE_PIC) -C sql link_sources
	#(MAKE_PIC) -C libmysql link_sources
	#(MAKE_PIC) -C strings
	#(MAKE_PIC) -C regex
	#(MAKE_PIC) -C mysys
	#(MAKE_PIC) -C dbug
	#(MAKE_PIC) -C vio
	#(MAKE_PIC) -C storage
	#(MAKE_PIC) -C extra/yassl
	#(MAKE_PIC) -C cmd-line-utils
	#(MAKE_PIC) -C sql lex_hash.h
	$(MAKE_PIC) -C scripts
	# Build libmysqld itself
	$(MAKE_PIC) -C libmysqld
	
	touch $@

clean: clean-patched unpatch
	rm -rf debian/patched
clean-patched:
	@echo "RULES.clean-patched"
	dh_testdir 
	dh_testroot
	rm -f configure-stamp*
	rm -f build-stamp*
	rm -f testsuite-stamp
	
	[ ! -f Makefile ] || $(MAKE) clean
	[ ! -d mysql-test/var ] || rm -rf mysql-test/var
	
	rm -rf $(BUILDDIR) $(BUILDDIR_PIC)

	debconf-updatepo
	rm -f $(EXPORTED_SOURCE_TARBALL)
	dh_clean -v


install:
install install-pic: build
	@echo "RULES.$@"
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# some self written manpages which hopefully
	# gets overwritten sooner or later with upstreams
	mkdir -p $(TMP)/usr/share/man/man1/
	mkdir -p $(TMP)/usr/share/man/man8/
	cp debian/additions/*.1 $(TMP)/usr/share/man/man1/
	mkdir -p $(TMP)/etc/mysql/conf.d/
	cp debian/additions/mysqld_safe_syslog.cnf $(TMP)/etc/mysql/conf.d/

	# make install (trailing slash needed for innobase)
	cd $(builddir) && $(MAKE) install DESTDIR=$(TMP)/
		
	# After installing, remove rpath to make lintian happy.
	set +e; \
	find ./debian/tmp/ -type f -print0 \
		| xargs -0 --no-run-if-empty chrpath -k 2>/dev/null \
		| fgrep RPATH= \
		| cut -d: -f 1 \
		| xargs --no-run-if-empty chrpath -d; \
	set -e

	# libmysqlclient: move shared libraries (but not the rest like libheap.a & co)
	#mv $(TMP)/usr/lib/mysql/libmysqlclient* $(TMP)/usr/lib
	#perl -pi -e 's#/usr/lib/mysql#/usr/lib#' $(TMP)/usr/lib/libmysqlclient.la
	#perl -pi -e 's#/usr/lib/mysql#/usr/lib#' $(TMP)/usr/lib/libmysqlclient_r.la
	# Check if our beloved versioned symbols are really there
	#if [ "`objdump -T $(TMP)/usr/lib/libmysqlclient.so.16.0.0 | grep -c libmysqlclient_16`" -lt 500 ]; then \
	#  echo "ERROR: versioned symbols are absent"; \
	#  exit 1; \
	#fi     
	# libmysqlclient_r is now a symlink to libmysqlclient. But it is
	# created wrong by the cmake build system and points at
	# libmysqlclient.so instead of the corresponding versioned lib.
	for i in `ls $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/libmysqlclient.so*` ; do \
		rlib=`basename $$i | sed -e 's/libmysqlclient\./libmysqlclient_r./'` ;\
		ln -sf `basename $$i` $(TMP)/usr/lib/$(DEB_HOST_MULTIARCH)/$$rlib ;\
	done

	# libmysqlclient-dev: forgotten header file since 3.23.25?
	#cp $(BUILDDIR)/include/my_config.h $(TMP)/usr/include/mysql/
	#cp include/my_dir.h $(TMP)/usr/include/mysql/
	# install libmysqld built with -FPIC
	install -d -m 0755 -o root -g root $(TMP)/usr/lib/mysql
	install -m 0644 -o root -g root $(BUILDDIR_PIC)/libmysqld/libmysqld.a $(TMP)/usr/lib/mysql/libmysqld_pic.a
	# mysql_config won't report the -fPIC, so give libmysqld-pic users a way to get their flags

## mysql-5.5 5.5.32

=== debian/changelog ===
mysql-5.5 (5.5.32-0ubuntu7) saucy; urgency=low

  * d/rules, d/control: remove gcc-4.4 dependency and disable X86 assembly in
    taocrypt (LP: #1162139).
    - Cherry-pick from Debian svn r2231 with thanks to Clint Byrum.

 -- Robie Basak <robie.basak@ubuntu.com>  Wed, 18 Sep 2013 10:02:09 +0000

mysql-5.5 (5.5.32-0ubuntu6) saucy; urgency=low

  * d/tests/upstream: Redirect stderr>stdout to fix DEP-8 test failure. 

 -- James Page <james.page@ubuntu.com>  Fri, 30 Aug 2013 11:01:02 +0100

mysql-5.5 (5.5.32-0ubuntu5) saucy; urgency=low

  * Drop unnecessary depends on versioned upstart. Apparmor loading helper
    has been available for more than one LTS release now, so explicit
    dependency is not required any more.

 -- Dmitrijs Ledkovs <dmitrij.ledkov@ubuntu.com>  Thu, 29 Aug 2013 14:34:32 +0100

mysql-5.5 (5.5.32-0ubuntu4) saucy; urgency=low

  * d/tests/upstream: Remove trailing / from --vardir to fix DEP-8 test
    failures (LP: #1216008).

 -- James Page <james.page@ubuntu.com>  Thu, 29 Aug 2013 14:10:52 +0100

mysql-5.5 (5.5.32-0ubuntu3) saucy; urgency=low

  * Revert 5.5.32-0ubuntu2, which caused a severe regression making the
    package uninstallable. See LP: #1121874 for details.

 -- Robie Basak <robie.basak@ubuntu.com>  Tue, 27 Aug 2013 11:55:13 +0000

mysql-5.5 (5.5.32-0ubuntu2) saucy-proposed; urgency=low

  [Eduardo Damato]
  * Fix upstart script to account for datadir disk shortage (LP: #1121874) 

 -- Adam Stokes <adam.stokes@ubuntu.com>  Wed, 31 Jul 2013 15:21:15 -0400

mysql-5.5 (5.5.32-0ubuntu1) saucy; urgency=low

  * SECURITY UPDATE: Update to 5.5.32 to fix security issues (LP: #1203828)
    - http://www.oracle.com/technetwork/topics/security/cpujuly2013-1899826.html
    - CVE-2013-1861
    - CVE-2013-3783
    - CVE-2013-3793
    - CVE-2013-3802
    - CVE-2013-3804
    - CVE-2013-3809
    - CVE-2013-3812
  * SECURITY UPDATE: insecure creation of debian.cnf file
    - debian/mysql-server-5.5.postinst: set umask to 066 before creating
      debian.cnf.
    - CVE-2013-2162
  * Fix FTBFS from test suite failure
    - debian/patches/72_fix_rpl_deadlock_innodb_test.patch: ignore warning
      from rpl.rpl_deadlock_innodb test in mysql-test/include/mtr_warnings.sql.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 23 Jul 2013 08:51:03 -0400

mysql-5.5 (5.5.31-0ubuntu1) saucy; urgency=low

  * Adjust Apparmor profile to allow reading PID file (LP: #1185573)

 -- Simon Deziel <simon.deziel@gmail.com>  Wed, 29 May 2013 16:14:02 -0400

mysql-5.5 (5.5.31-0ubuntu0.13.04.1) raring-security; urgency=low

  * SECURITY UPDATE: Update to 5.5.31 to fix security issues (LP: #1170516)
    - http://www.oracle.com/technetwork/topics/security/cpuapr2013-1899555.html
  * debian/patches/71_disable_rpl_tests.patch: refreshed.
  * debian/patches/fix-mysqldump-test.patch: removed, fixed differently
    upstream

 -- Seth Arnold <seth.arnold@canonical.com>  Thu, 18 Apr 2013 18:25:54 -0700

## mysql-5.5 5.5.34

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-# Copyright (c) 2006, 2012, Oracle and/or its affiliates. All rights reserved.
+# Copyright (c) 2006, 2013, Oracle and/or its affiliates. All rights reserved.
 # 
 # This program is free software; you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -302,6 +302,7 @@
 IF(WITH_UNIT_TESTS)
   ADD_SUBDIRECTORY(unittest/mytap)
   ADD_SUBDIRECTORY(unittest/mysys)
+  ADD_SUBDIRECTORY(unittest/my_decimal)
 ENDIF()
 
 ADD_SUBDIRECTORY(extra)

=== debian/changelog ===
mysql-5.5 (5.5.34-0ubuntu0.13.04.1) raring-security; urgency=low

  * SECURITY UPDATE: Update to 5.5.34 to fix security issues (LP: #1243253)
    - http://www.oracle.com/technetwork/topics/security/cpuoct2013-1899837.html
    - CVE-2013-3839
    - CVE-2013-5807

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 22 Oct 2013 14:59:35 -0400

mysql-5.5 (5.5.32-0ubuntu0.13.04.1) raring-security; urgency=low

  * SECURITY UPDATE: Update to 5.5.32 to fix security issues (LP: #1203828)
    - http://www.oracle.com/technetwork/topics/security/cpujuly2013-1899826.html
    - CVE-2013-1861
    - CVE-2013-3783
    - CVE-2013-3793
    - CVE-2013-3802
    - CVE-2013-3804
    - CVE-2013-3809
    - CVE-2013-3812
  * SECURITY UPDATE: insecure creation of debian.cnf file
    - debian/mysql-server-5.5.postinst: set umask to 066 before creating
      debian.cnf.
    - CVE-2013-2162
  * Adjust Apparmor profile to allow reading PID file. (LP: #1185573)
  * Fix FTBFS from test suite failure
    - debian/patches/72_fix_rpl_deadlock_innodb_test.patch: ignore warning
      from rpl.rpl_deadlock_innodb test in mysql-test/include/mtr_warnings.sql.

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Tue, 23 Jul 2013 16:40:38 -0400
